Package org.eclipse.rdf4j.sparqlbuilder.graphpattern

## Interface TriplePattern

- All Superinterfaces:
    `GraphPattern`, `QueryElement`

      public interface TriplePattern
      extends GraphPattern

  Denotes a SPARQL Triple Pattern
  See Also:
    Triple pattern syntax, blank node syntax

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `SUFFIX` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default TriplePattern` | `andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer, Boolean... objects)` | Wrapper for `andHas(Consumer, RdfObject...)` converting the `Boolean` `objects` to `RdfObject`s.
    `default TriplePattern` | `andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer, Number... objects)` | Wrapper for `andHas(Consumer, RdfObject...)` converting the `Number` `objects` to `RdfObject`s.
    `default TriplePattern` | `andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer, String... objects)` | Wrapper for `andHas(Consumer, RdfObject...)` converting the `String` `objects` to `RdfObject`s.
    `default TriplePattern` | `andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer, Value... objects)` | Wrapper for `andHas(Consumer, RdfObject...)` converting the `Value` `objects` to `RdfObject`s.
    `default TriplePattern` | `andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer, RdfObject... objects)` | Add a property path with an object list describing this triple pattern's subject
    `default TriplePattern` | `andHas​(IRI predicate, Boolean... objects)` | Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Boolean and converts them to BooleanLiterals
    `default TriplePattern` | `andHas​(IRI predicate, Number... objects)` | Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Numbers and converts them to NumberLiterals
    `default TriplePattern` | `andHas​(IRI predicate, String... objects)` | Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Strings and converts them to StringLiterals
    `default TriplePattern` | `andHas​(IRI predicate, RdfObject... objects)` | Add predicate-object lists describing this triple pattern's subject
    `TriplePattern` | `andHas​(RdfPredicateObjectList... lists)` | Add predicate-object lists describing this triple pattern's subject
    `default TriplePattern` | `andHas​(RdfPredicate predicate, Boolean... objects)` | Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Boolean and converts them to BooleanLiterals
    `default TriplePattern` | `andHas​(RdfPredicate predicate, Number... objects)` | Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Numbers and converts them to NumberLiterals
    `default TriplePattern` | `andHas​(RdfPredicate predicate, String... objects)` | Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Strings and converts them to StringLiterals
    `default TriplePattern` | `andHas​(RdfPredicate predicate, Value... objects)` | Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes `Value`s and converts them to StringLiterals
    `default TriplePattern` | `andHas​(RdfPredicate predicate, RdfObject... objects)` | Add predicate-object lists describing this triple pattern's subject
    `default TriplePattern` | `andIsA​(RdfObject object)` | Use the built-in RDF shortcut `a` for `rdf:type` to specify the subject's type
    `default boolean` | `isEmpty()` |

    - ### Methods inherited from interface org.eclipse.rdf4j.sparqlbuilder.graphpattern.GraphPattern

      `and, filter, filterExists, filterExists, filterNotExists, from, minus, optional, optional, union`

    - ### Methods inherited from interface org.eclipse.rdf4j.sparqlbuilder.core.QueryElement

      `getQueryString`

- - ### Field Detail

    - #### SUFFIX

          static final String SUFFIX

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### andHas

          default TriplePattern andHas​(RdfPredicate predicate,
                                       RdfObject... objects)

      Add predicate-object lists describing this triple pattern's subject
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(IRI predicate,
                                       RdfObject... objects)

      Add predicate-object lists describing this triple pattern's subject
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          TriplePattern andHas​(RdfPredicateObjectList... lists)

      Add predicate-object lists describing this triple pattern's subject
      Parameters:
        `lists` - the `RdfPredicateObjectList`(s) to add
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(RdfPredicate predicate,
                                       Value... objects)

      Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes `Value`s and converts them to StringLiterals
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(RdfPredicate predicate,
                                       String... objects)

      Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Strings and converts them to StringLiterals
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(IRI predicate,
                                       String... objects)

      Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Strings and converts them to StringLiterals
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(RdfPredicate predicate,
                                       Boolean... objects)

      Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Boolean and converts them to BooleanLiterals
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(IRI predicate,
                                       Boolean... objects)

      Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Boolean and converts them to BooleanLiterals
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(RdfPredicate predicate,
                                       Number... objects)

      Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Numbers and converts them to NumberLiterals
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(IRI predicate,
                                       Number... objects)

      Convenience version of `andHas(RdfPredicate, RdfObject...)` that takes Numbers and converts them to NumberLiterals
      Parameters:
        `predicate` - the predicate to use to describe this triple pattern's subject
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer,
                                       RdfObject... objects)

      Add a property path with an object list describing this triple pattern's subject
      Parameters:
        `propertyPathConfigurer` - an object accepting an `EmptyPropertyPathBuilder` that configures it as needed
        `objects` - the corresponding object(s)
      Returns:
        this triple pattern

    - #### andHas

          default TriplePattern andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer,
                                       Value... objects)

      Wrapper for `andHas(Consumer, RdfObject...)` converting the `Value` `objects` to `RdfObject`s.

    - #### andHas

          default TriplePattern andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer,
                                       String... objects)

      Wrapper for `andHas(Consumer, RdfObject...)` converting the `String` `objects` to `RdfObject`s.

    - #### andHas

          default TriplePattern andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer,
                                       Number... objects)

      Wrapper for `andHas(Consumer, RdfObject...)` converting the `Number` `objects` to `RdfObject`s.

    - #### andHas

          default TriplePattern andHas​(Consumer<EmptyPropertyPathBuilder> propertyPathConfigurer,
                                       Boolean... objects)

      Wrapper for `andHas(Consumer, RdfObject...)` converting the `Boolean` `objects` to `RdfObject`s.

    - #### andIsA

          default TriplePattern andIsA​(RdfObject object)

      Use the built-in RDF shortcut `a` for `rdf:type` to specify the subject's type
      Parameters:
        `object` - the object describing this triple pattern's subject's `rdf:type`
      Returns:
        this triple pattern
      See Also:
        RDF Type abbreviation

    - #### isEmpty

          default boolean isEmpty()

      Specified by:
        `isEmpty` in interface `GraphPattern`
      Returns:
        if this pattern is a collection of GraphPatterns (ie., Group or Alternative patterns), returns if the collection contains any patterns